# TODO
# - split perl-devel for Devel::Peek?
#
# Conditional build:
%bcond_without	autodeps	# don't BR packages needed only for resolving deps
%bcond_without	tests		# perform "make test"
#
%include	/usr/lib/rpm/macros.perl
Summary:	Perlbal - Reverse-proxy load balancer and webserver
Summary(pl.UTF-8):	Perlbal - odwrotne proxy z równoważeniem obciążenia oraz serwer WWW
Name:		Perlbal
Version:	1.79
Release:	1
# same as perl
License:	GPL v1+ or Artistic
Group:		Development/Languages/Perl
Source0:	http://www.cpan.org/modules/by-authors/id/D/DO/DORMANDO/%{name}-%{version}.tar.gz
# Source0-md5:	565ba843bd3b8b38287e20eceab62fe5
Source1:	perlbal.init
Source2:	perlbal.sysconfig
Patch0:		%{name}-no_use_lib.patch
Patch2:		perlbal-freeport.patch
URL:		http://www.danga.com/perlbal/
BuildRequires:	perl-devel >= 1:5.8.0
BuildRequires:	rpm-perlprov >= 4.1-13
BuildRequires:	rpmbuild(macros) >= 1.228
%if %{with autodeps} || %{with tests}
BuildRequires:	perl-BSD-Resource
BuildRequires:	perl-Danga-Socket >= 1.44
BuildRequires:	perl-IO-AIO
BuildRequires:	perl-Net-Netmask
BuildRequires:	perl-Sys-Syscall
BuildRequires:	perl-libwww
%endif
Requires(post,preun):	/sbin/chkconfig
Requires:	rc-scripts
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_noautoreq	'perl(Perlbal.*)'

%description
Perlbal is a single-threaded event-based server supporting HTTP load
balancing, web serving, and a mix of the two.

One of the defining things about Perlbal is that almost everything can
be configured or reconfigured on the fly without needing to restart
the software. A basic configuration file containing a management port
enables you to easily perform operations on a running instance of
Perlbal.

%description -l pl.UTF-8
Perlbal to jednowątkowy, oparty na zdarzeniach serwer obsługujący
równoważenie obciążenia HTTP, świadczenie usług WWW oraz połączenie
obu.

Jedną z cech charakterystycznych dla Perlbala jest to, że prawie
wszystko można skonfigurować lub przekonfigurować w locie, bez
potrzeby restartu programu. Podstawowy plik konfiguracyjny zawierający
port zarządzający pozwala na łatwe wykonywanie operacji na działającej
instancji Perlbala.

%prep
%setup -q
%patch0 -p1
%patch2 -p1

%build
%{__perl} Makefile.PL \
	INSTALLDIRS=vendor
%{__make}

%if %{with tests}
# randomize the first base port a little
export TEST_TCP_FREE_PORT=$(perl -e 'print (4096 + $$) % 65536')
%{__make} test
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} pure_install \
	DESTDIR=$RPM_BUILD_ROOT

install -D %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/perlbal
install -D %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/perlbal
cp -r conf $RPM_BUILD_ROOT%{_sysconfdir}/perlbal
rm $RPM_BUILD_ROOT%{perl_vendorarch}/auto/Perlbal/.packlist

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add perlbal
%service perlbal restart

%preun
if [ "$1" = "0" ]; then
	%service -q perlbal stop
	/sbin/chkconfig --del perlbal
fi

%files
%defattr(644,root,root,755)
%doc CHANGES doc conf
%dir %{_sysconfdir}/perlbal
%attr(640,root,root) %{_sysconfdir}/perlbal/*.conf
%attr(640,root,root) %{_sysconfdir}/perlbal/*.dat
%attr(754,root,root) /etc/rc.d/init.d/perlbal
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/perlbal
%attr(755,root,root) %{_bindir}/perlbal
%{perl_vendorlib}/*.pm
%{perl_vendorlib}/Perlbal
%{_mandir}/man?/*
%changelog
* Sun Apr 28 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/Perlbal.git;a=log;h=master

* Sun Jan 22 2012 zbyniu <zbyniu@pld-linux.org> 4af5576
- up to 1.79

* Mon Jun 06 2011 marti <marti@pld-linux.org> 521fb61
- up to 1.78

* Tue Feb 03 2009 Jakub Bogusz <qboosh@pld-linux.org> ac21489
- outdated

* Mon Feb 02 2009 radek <radek@pld-linux.org> 4dddc3d
- release 2, BR: perl-IO-AIO perl-Net-Netmask

* Mon Feb 02 2009 radek <radek@pld-linux.org> 71a464f
- version 1.72; tests back on (this is HEAD, not AC-branch)

* Tue Jan 15 2008 Elan Ruusamäe <glen@pld-linux.org> 5d0ba92
- sane config permissions

* Tue Jan 15 2008 Elan Ruusamäe <glen@pld-linux.org> db4687e
- possible todo

* Sun Jan 13 2008 Elan Ruusamäe <glen@pld-linux.org> 058e076
- most of the tests don't run on ac, so no point enabling

* Sun Jan 13 2008 Elan Ruusamäe <glen@pld-linux.org> e0ec2e4
- uid not good either (same on ac)

* Sun Jan 13 2008 Elan Ruusamäe <glen@pld-linux.org> 8cae574
- randomize base tests port

* Sun Jan 13 2008 Elan Ruusamäe <glen@pld-linux.org> e88357f
- allow override baseport for tests

* Sun Jan 13 2008 Elan Ruusamäe <glen@pld-linux.org> 6dec619
- something and nothing

* Sat Jan 12 2008 Elan Ruusamäe <glen@pld-linux.org> 451f8c7
- rel 3

* Fri Jan 04 2008 Jakub Bogusz <qboosh@pld-linux.org> e4d2282
- added try-restart action

* Fri Jan 04 2008 Jakub Bogusz <qboosh@pld-linux.org> b848b4d
- pl

* Sun Sep 16 2007 radek <radek@pld-linux.org> 76d6c43
- really release 2 this time

* Sun Sep 16 2007 radek <radek@pld-linux.org> 1f59218
- release 2: added -test_15_webserver.patch

* Sun Sep 16 2007 radek <radek@pld-linux.org> 459d054
- fix for t/15-webserver's assumption of time standing still

* Sun Sep 16 2007 radek <radek@pld-linux.org> 8c9f6f7
- new

